/*
 * ATTiny3216_Porttest.cpp
 *
 * Created: 11.06.2020 15:34:47
 * Author : Micha
 *
 * Attiny3216, 1616 etc.
 * testet, ob die Ports des Controllers (noch) in Ordnung sind...
 *
 * Hardware: RDKS-Sender mit ATTiny3216
 */ 

#ifndef F_CPU
#define F_CPU 3333333UL
#endif

#include <avr/io.h>
#include <Util/delay.h>

void CLKCTRL_init(void)
{
	#if (F_CPU == 1000000UL)                     /* 1MHz, 16/16, set fuse for 16 MHz */
	_PROTECTED_WRITE(CLKCTRL.MCLKCTRLB, CLKCTRL_PDIV_16X_gc | CLKCTRL_PEN_bm);
	#endif
	
	#if (F_CPU == 20000000UL)                  /* 20MHz, no division */
	_PROTECTED_WRITE(CLKCTRL.MCLKCTRLB, 0 << CLKCTRL_PEN_bp);
	#endif
	
	#if (F_CPU == 3333333UL)					/* 3.3 MHz bei Fuse = 20 MHz / 6 = 3.3 MHz*/
	_PROTECTED_WRITE(CLKCTRL.MCLKCTRLB, CLKCTRL_PDIV_6X_gc | CLKCTRL_PEN_bm);  /* default 3.33MHz (20MHz/6) set fuse for 20MHz */
	#endif
}

void io_init()
{
	PORTA.DIRSET = 254;				// PortA0...7 Output (except PA0/UPDI)
	PORTB.DIRSET = 63;				// PortB0...5 Output
	PORTC.DIRSET =  15;				// PortC0...3 Output
}

int main(void)
{
	
	CLKCTRL_init();					// 3,3 MHz Takt
	
	io_init();
	
	// Alle Ports auf Ausgang und blinken lassen...
	
    while (1) 
    {
		PORTA.OUTTGL = 254;
		PORTB.OUTTGL = 63;
		PORTC.OUTTGL = 15;
		_delay_ms(100);
    }
}

