/*
 * AtTiny3216_UART_Reset_Test.cpp
 *
 * Created: 14.11.2019 00:22:11
 * Author : Micha
 */ 

// Demo eines Software-Reset, USART-Ausgabe

#define F_CPU 3333333UL

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "USART0.h"


	/*
	ATtiny3216/1616 AtTiny Series 1, Syntax:
	----------------------------------------
	_bm = BitMask
	_bp = BitPosition
	_gm = GroupMask
	_gp = GroupPosition
	_gc = Group Control (benutzt in enums)
	*/

void SoftwareReset()
{
	CPU_CCP = 0xD8;
	RSTCTRL_SWRR = 1;
}

int main(void)
{
	USART0_init();			// 9600 Baud
	
    while (1) 
    {
		USART0_sendString( (char *) "Start\r\n");
		_delay_ms(5000);
		SoftwareReset();
		
		USART0_sendString( (char *) "Das sollte nicht zu sehen sein\r\n");
		_delay_ms(5000);
    }
}

